Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# IdeBrush Class Reference

`#include <deBrush.hpp>`

Inheritance diagram for IdeBrush:

[legend]
Collaboration diagram for IdeBrush:

[legend]
List of all members.

## Public Types
enum | deBrushType { Brush_Group, Brush_Block, Brush_Cylinder, Brush_Lathed, Brush_Extruded, Brush_Static, Brush_Line, Brush_Prism, Brush_Bezier, Brush_LargeStatic }
## Public Member Functions
virtual void * | GetBrushInterface (deBrushType Type) const=0
virtual void | GetWorldTransform (deTransformInfo &Matrix) const=0
virtual void | Rotate (deVec3d &Center, deVec3d &Axis, deDouble Degrees)=0
virtual void | Rotate (deVec3d &Center, deTransformInfo &M)=0
virtual void | Translate (deVec3d &Delta)=0
virtual void | Scale (deVec3d &Center, deDouble scale)=0
virtual deBoolean | Update ()=0
virtual long | GetLOD () const=0
virtual long | GetLOD2 () const=0
virtual void | SetLOD (long LOD)=0
virtual void | SetLOD2 (long LOD2)=0
virtual long | GetTexFacesNum ()=0
virtual long | GetTexCoordsNum (long faceindex)=0
virtual deTexCoord | GetTexCoord (long faceindex, long index)=0
virtual void | SetTexCoord (long faceindex, long index, deTexCoord &coord)=0
virtual void | SetTexCoord (long faceindex, long index, deFloat u, deFloat v)=0
virtual void | SetTexture (long faceindex, IdeRenderTexture *tex)=0
virtual IdeRenderTexture * | GetTexture (long faceindex)=0
virtual void | SetSmooth (deBoolean SmoothNotSharp)=0
virtual deBoolean | GetSmooth ()=0
virtual long | GetNumCVs ()=0
virtual void | GetCVList (deVec3d buffer[])=0
virtual deVec3d | GetCV (long num)=0
virtual deBoolean | SetCV (long num, deVec3d &CV)=0
virtual deBoolean | SetCVList (long num, deVec3d CVList[])=0
virtual deBoolean | AddCV (deVec3d &point)=0
virtual IdeBrush * | Copy ()=0
virtual void | GetAABB (deVec3d &Mins, deVec3d &Maxs)=0
virtual long | GetNumVBs ()=0
virtual IdeVertexBuffer * | GetVertexBuffer (long index)=0
virtual void | SetDiffuseColor (deARGB color)=0
virtual deARGB | GetDiffuseColor ()=0
virtual void | Subtract (IdeBrush *cutter)=0
## Protected Member Functions
virtual | ~IdeBrush ()

## Detailed Description

This is the basic geometry building block of the engine. It can generate its own geometry from inputs or use geometry supplied by the user.

## Member Enumeration Documentation

enum IdeBrush::deBrushType

  | Enumeration values:
  Brush_Group |
  Brush_Block |
  Brush_Cylinder |
  Brush_Lathed |
  Brush_Extruded |
  Brush_Static |
  Brush_Line |
  Brush_Prism |
  Brush_Bezier |
  Brush_LargeStatic |

## Constructor & Destructor Documentation

virtual IdeBrush::~IdeBrush | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

virtual deBoolean IdeBrush::AddCV | ( | deVec3d & | point | ) | `[pure virtual]`

| Implemented in deBrush.

virtual IdeBrush* IdeBrush::Copy | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::GetAABB | ( | deVec3d & | Mins,
|  | deVec3d & | Maxs
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void* IdeBrush::GetBrushInterface | ( | deBrushType | Type | ) | const`[pure virtual]`

| Implemented in deBrush.

virtual deVec3d IdeBrush::GetCV | ( | long | num | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::GetCVList | ( | deVec3d | buffer[] | ) | `[pure virtual]`

| Implemented in deBrush.

virtual deARGB IdeBrush::GetDiffuseColor | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetLOD | ( |  | ) | const`[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetLOD2 | ( |  | ) | const`[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetNumCVs | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetNumVBs | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual deBoolean IdeBrush::GetSmooth | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual deTexCoord IdeBrush::GetTexCoord | ( | long | faceindex,
|  | long | index
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetTexCoordsNum | ( | long | faceindex | ) | `[pure virtual]`

| Implemented in deBrush.

virtual long IdeBrush::GetTexFacesNum | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

virtual IdeRenderTexture* IdeBrush::GetTexture | ( | long | faceindex | ) | `[pure virtual]`

| Implemented in deBrush.

virtual IdeVertexBuffer* IdeBrush::GetVertexBuffer | ( | long | index | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::GetWorldTransform | ( | deTransformInfo & | Matrix | ) | const`[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::Rotate | ( | deVec3d & | Center,
|  | deTransformInfo & | M
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::Rotate | ( | deVec3d & | Center,
|  | deVec3d & | Axis,
|  | deDouble | Degrees
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::Scale | ( | deVec3d & | Center,
|  | deDouble | scale
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual deBoolean IdeBrush::SetCV | ( | long | num,
|  | deVec3d & | CV
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual deBoolean IdeBrush::SetCVList | ( | long | num,
|  | deVec3d | CVList[]
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetDiffuseColor | ( | deARGB | color | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetLOD | ( | long | LOD | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetLOD2 | ( | long | LOD2 | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetSmooth | ( | deBoolean | SmoothNotSharp | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetTexCoord | ( | long | faceindex,
|  | long | index,
|  | deFloat | u,
|  | deFloat | v
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetTexCoord | ( | long | faceindex,
|  | long | index,
|  | deTexCoord & | coord
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::SetTexture | ( | long | faceindex,
|  | IdeRenderTexture * | tex
| ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::Subtract | ( | IdeBrush * | cutter | ) | `[pure virtual]`

| Implemented in deBrush.

virtual void IdeBrush::Translate | ( | deVec3d & | Delta | ) | `[pure virtual]`

| Implemented in deBrush.

virtual deBoolean IdeBrush::Update | ( |  | ) | `[pure virtual]`

| Implemented in deBrush.

The documentation for this class was generated from the following file:

- deBrush.hpp